/******************************************************************************
 *                       ____    _    _____                                   *
 *                      / ___|  / \  |  ___|    C++                           *
 *                     | |     / _ \ | |_       Actor                         *
 *                     | |___ / ___ \|  _|      Framework                     *
 *                      \____/_/   \_|_|                                      *
 *                                                                            *
 * Copyright (C) 2011 - 2015                                                  *
 * Dominik Charousset <dominik.charousset (at) haw-hamburg.de>                *
 *                                                                            *
 * Distributed under the terms and conditions of the BSD 3-Clause License or  *
 * (at your option) under the terms and conditions of the Boost Software      *
 * License 1.0. See accompanying files LICENSE and LICENSE_ALTERNATIVE.       *
 *                                                                            *
 * If you did not receive a copy of the license files, see                    *
 * http://opensource.org/licenses/BSD-3-Clause and                            *
 * http://www.boost.org/LICENSE_1_0.txt.                                      *
 ******************************************************************************/

#include "caf/config.hpp"

// exclude this suite; the profiled coordinator currently depends on POSIX
#ifndef CAF_WINDOWS

#define CAF_SUITE profiled_coordinator
#include "caf/test/unit_test.hpp"

#include "caf/config.hpp"
#include "caf/shutdown.hpp"

#include "caf/set_scheduler.hpp"
#include "caf/scheduler/profiled_coordinator.hpp"

using namespace caf;

CAF_TEST(test_profiled_coordinator) {
  set_scheduler(new scheduler::profiled_coordinator<>{"/dev/null"});
  shutdown();
}

#endif // CAF_WINDOWS
